/**********************************************
 *  buff.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef BUFF_H
#define BUFF_H

#define BUFF_SIZE      (PATH_MAX*2)
#define COMM_SIZE      (PATH_MAX)
#define JOBB_SIZE       8192
#define LIST_SIZE       2048
#define CONB_SIZE       1024
#define HIST_SIZE       1024
#define CHIST_SIZE      1024
#define INFO_SIZE        512
#define DLOG_SIZE        512
#define HEAD_SIZE          8

#define STATUS_MSG      ":->"
#define ERROR_MSG       ":-<"
#define DEBUG_MSG       ":-|"
#define LIST_MSG        "|||"
#define PNTR_MSG        ">>>"
#define DEL_ENTRY_MSG   "<--"
#define MISC_MSG        "-->"
#define REPORT_MSG      "__>"

enum {
    CONB_NEWLINE,
    CONB_NO_NEWLINE
};

void         buff_init       ();
void         buff_clear      ();
unsigned int buff_get_bytec  ();
int          outb_empty      ();
void         outb_clear      ();
void         outb_sort       ();
void         outb_add        (const char *, ...);
void         outb_flush      ();
int          outb_check      (char);
void         conb_flush      ();
void         conb_add        (const char *, ...);
void         conb_add_n      (char *);
void         show_user       (const char *, ...);
void         show_user_n     (char *);
void         dlog_add        (const char *, ...);
void         mess_comm       ();         /* user */
void         dlog_show_comm  ();         /* user */
void         dlog_clear_comm ();     	 /* user */

#endif
