/**********************************************
 *  command.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef COMMAND_H
#define COMMAND_H

#define END_COMM '\n'

enum {
    PRINT_INFO,
    PRINT_GPL,
    PRINT_HELP,
    EXIT_DECODER,

    PLAY_FILE,
    STOP_FILE,
    PAUSE_FILE,
    RESUME_FILE,
    NEXT_FILE,
    PREVIOUS_FILE,
    SEEK_FILE,
    SET_MIXER,
    MUTE_OUTPUT,
    UNMUTE_OUTPUT,
    REPORT_STATE,
    REPORT_TIME_STATE,

    ADD_LIST,
    REMOVE_LIST,
    RESET_LIST,
    RENAME_LIST,
    USE_LIST,
    USE_NEXT_LIST,
    USE_PREV_LIST,
    EDIT_LIST,

    PRINT_LIST,
    PRINT_LIST_STATUS,

    ADD_TO_LIST,
    ADD_FILE_TO_LIST,
    ADD_DIR_NORM,
    ADD_DIR_RECURSE,
    TOGGLE_READ_TAGS,

    PLAY_LIST_INDEX,
    MOVE_LIST_INDEX,
    DELETE_LIST_INDEX,
    SET_INDEX_WEIGHT,
    SORT_LIST,
    SAVE_LIST,
    LOAD_LIST,

    SAVE_ALL_LISTS,
    LOAD_ALL_LISTS,

    PRINT_QUEUE,
    QUEUE_INDEX,
    QUEUE_FILE,
    DELETE_QUEUE_INDEX,
    RESIZE_QUEUE,

    SET_MODE_ONCE,
    SET_MODE_REPEAT,
    SET_MODE_TRANDOM,
    SET_MODE_SRANDOM,

    SET_MODE_LEARN,
    SET_LEARN_WEIGHTS,

    SET_PREF_TF,
    SET_PREF_TPF,
    SET_PREF_PF,
    SET_PREF_F,

    AUTO_REPORT,
    DJ_MODE,

    SET_STAMP_OFF,
    SET_STAMP_TIMP,
    SET_STAMP_TIML,

    SHOW_TAG,
    ADD_TAG,
    PRINT_STYLES,
    PRINT_PLAYERS,
    ADD_PLAYER,

    SHOW_EQ_BANDS,
    SET_EQ_BAND,
    ENABLE_EQ,
    DISABLE_EQ,

    PRINT_EVENTS,
    ADD_EVENT,
    REMOVE_EVENT,

    PRINT_KEYS,
    MOD_KEY,

    SOURCE_FILE,
    SHOW_CHIST,
    ADD_ALIAS,
    REMOVE_ALIAS,
    PRINT_JOBS,
    FLUSH_JOB_BUFF,
    SEND_JOB_2FG,
    SEND_JOB_2BG,
    SHOW_ENVIRON,
    SET_ENVIRON,
    MESS_CMND,
    CHANGE_DIR,

    MULTIPLE_AUDIO,
    AUTO_RECOVER,
    START_DECODER,
    SET_XAUDIO_OUTPUT,
    PRINT_DLOG,
    CLEAR_DLOG,

    NO_BUILTIN_COMM
};

#define NUM_COMM  ((int) NO_BUILTIN_COMM)

typedef struct CommandDef_s {
    void (*func) ();
    char  *name;
    char  *help;
} CommandDef;

void         com_init           ();
void         com_clear          ();
unsigned int com_get_bytec      ();
void         com_beep           ();
int          com_find_match     (char *);
int          com_test_background(int *);
void         com_setup_child    (int);
void         com_exec           ();		/* user (indirect) */
void         com_handle         (char *);
void         com_info_clear     ();
void         com_ctrl_str       (int, int);
void         com_delete         ();
int          com_monitor        ();
void         prompt             (int);
void         update_prompt      (int);

#endif
