/**********************************************
 *  dbuf.h                                                          
 *                                      
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef DBUF_H
#define DBUF_H

enum {
    DCHAR_NORM,
    DCHAR_SHIFT,
    DCHAR_GROW
};

typedef struct DCBNode_s {
    char           *ptr;
    short           info;
    unsigned short  len;
} DCBNode;

typedef struct DCharBuf_s {
    char        *name;
    unsigned int bytec;
    int          var;
    int          size;
    int          len;
    int          pos;
    int          mode;
    int          rate;
    DCBNode     *buf;
} DCharBuf;

unsigned       dbuf_get_bytec   (DCharBuf *);
short          dbuf_get_info    (DCharBuf *, int);
void           dbuf_set_info    (DCharBuf *, int, short);
void           dbuf_verify      (DCharBuf *);
int            dbuf_resize      (DCharBuf *, int);
void           dbuf_free        (DCharBuf *);
DCharBuf      *dbuf_init        (char *, int, int, int);
void           dbuf_clear       (DCharBuf *);
int            dbuf_swap        (DCharBuf *, int, int);
int            dbuf_remove_range(DCharBuf *, int, int);
int            dbuf_remove      (DCharBuf *, int);
unsigned short dbuf_get_len     (DCharBuf *, int);
char          *dbuf_get         (DCharBuf *, int);
int            dbuf_add         (DCharBuf *, void *, int, short);
int            dbuf_add_ptr     (DCharBuf *, void *, int, short);
int            dbuf_add_str     (DCharBuf *, char *);
int            dbuf_add_stri    (DCharBuf *, char *, short);
void           dbuf_sort_str    (DCharBuf *);
int            dbuf_check_str   (DCharBuf *, char *);
int            dbuf_rem_str_dups(DCharBuf *);

#endif
