/**********************************************
 *  event.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef EVENT_H
#define EVENT_H

#define TIME_EVENT     ((unsigned int)  1)
#define LIST_EVENT     ((unsigned int)  2)
#define QUEUE_EVENT    ((unsigned int)  4)
#define ESTREAM_EVENT  ((unsigned int)  8)
#define SSTREAM_EVENT  ((unsigned int) 16)
#define EXIT_EVENT     ((unsigned int) 32)

typedef struct EventData_s {
    flag_t              persist;
    flag_t              quiet;
    int                 id;
    unsigned int        type;
    struct timeval      start;
    struct timeval      period;
    char               *info;
    char               *command;
    struct EventData_s *next;
} EventData;

void         event_init       ();
void         event_clear      ();
unsigned int event_get_bytec  ();
void         event_post       (unsigned int);
void         event_check      ();
void         event_print_comm ();	/* user */
void         event_add_comm   ();	/* user */
void         event_remove_comm();	/* user */

#endif
