/**********************************************
 *  extdec.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef EXTDEC_H
#define EXTDEC_H

enum {
    OUTP_NONE,
    OUTP_NORM,
    OUTP_QUIET,
    OUTP_BUFFERED
};

enum {
    SIGNAL_NONE,
    SIGNAL_TERM,
    SIGNAL_KILL
};

typedef struct PlayerDef_s {
    char               *name;
    char               *command;
    char               *sup_types;
    int                 output;
    int                 signal;
    struct PlayerDef_s *next;
} PlayerDef;

void         plyr_init       ();
void         plyr_clear      ();
unsigned int plyr_get_bytec  ();
void         plyr_print_comm ();		/* user */
void         plyr_add_comm   ();		/* user */
void         ext_pause       ();
void         ext_resume      ();
void         ext_stop        ();
void         ext_handle_death(pid_t);
void         ext_play        (PlayerDef *, char *);

#endif
