/**********************************************
 *  intdec.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef INTDEC_H
#define INTDEC_H

#define NOTIFY_MASK     (XA_NOTIFY_MASK_ERROR |\
			 XA_NOTIFY_MASK_DEBUG |\
			 XA_NOTIFY_MASK_PLAYER_STATE |\
			 XA_NOTIFY_MASK_INPUT_STATE |\
			 XA_NOTIFY_MASK_INPUT_TIMECODE |\
			 XA_NOTIFY_MASK_STREAM_DURATION |\
			 XA_NOTIFY_MASK_STREAM_PARAMETERS |\
                         XA_NOTIFY_MASK_STREAM_PROPERTIES |\
                         XA_NOTIFY_MASK_OUTPUT_VOLUME |\
                         XA_NOTIFY_MASK_OUTPUT_BALANCE |\
                         XA_NOTIFY_MASK_OUTPUT_PCM_LEVEL |\
                         XA_NOTIFY_MASK_OUTPUT_MASTER_LEVEL |\
                         XA_NOTIFY_MASK_OUTPUT_STATE)

#define MAX_EQ_BANDS        10
#define EQ_BAND_VAL_LOW    -128
#define EQ_BAND_VAL_HIGH    127
#define DEFAULT_GRANULARITY 20
#define DJ_GRANULARITY      1

typedef struct EQBandDef_s {
    int low; 
    int high;
} EQBandDef;

void         dec_init                ();
void         dec_clear               ();
unsigned int dec_get_bytec           ();
void         dec_play                (char *);
void         dec_stop                ();
void         dec_pause               ();
void         dec_resume              ();
void         dec_seek                (int, int);
void         dec_set_mixer           (int, int, int);
void         dec_close_input         ();
int          dec_close_output        ();
void         dec_close               ();
int          dec_get_read_pipe       ();
void         dec_state_change        (unsigned int);
void         dec_handle_message      ();
void         dec_monitor             ();
void         dec_set_output_comm     (); /* user */
void         dec_seek_comm           (); /* user */
void         dec_open_comm           (); /* user */
void         dec_mute_comm           (); /* user */
void         dec_unmute_comm         (); /* user */
void         dec_print_eq_comm       (); /* user */
void         dec_set_eq_band_comm    (); /* user */
void         dec_disable_eq_comm     (); /* user */
void         dec_enable_eq_comm      (); /* user */
void         dec_set_mixer_comm      (); /* user */
void         dec_toggle_dj_comm      (); /* user */
void         toggle_audio_procs_comm (); /* user */
void         toggle_auto_recover_comm(); /* user */

#endif
