/**********************************************
 *  keys.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef KEYS_H
#define KEYS_H

#define VOLUME_JUMP       4
#define SEEK_JUMP         3
#define BALANCE_JUMP      2

#define NUM_TERM_CTRL     36
#define NUM_TERM_USER     8

enum {
    TC_CLR,
    TC_CLR_TOBOT,
    TC_CLR_TOEOL,
    TC_ND,
    TC_UP,
    TC_CR,

    UP_ARROW,
    DOWN_ARROW,
    RIGHT_ARROW,
    LEFT_ARROW,
    HOME_KEY,
    END_KEY,
    INSERT_KEY,
    DELETE_KEY,
    PAGEUP_KEY,
    PAGEDOWN_KEY,
    F1_KEY,
    F2_KEY,
    F3_KEY,
    F4_KEY,
    F5_KEY,
    F6_KEY,
    F7_KEY,
    F8_KEY,
    F9_KEY,
    F10_KEY,
    F11_KEY,
    F12_KEY,

    UP_ARROW_2,
    DOWN_ARROW_2,
    RIGHT_ARROW_2,
    LEFT_ARROW_2,

    F1_KEY_2,
    F2_KEY_2,
    F3_KEY_2,
    F4_KEY_2
};

typedef struct TermCtrl_s {
    flag_t newl;
    char  *desc;
    char  *name;
    char  *string;
    char  *user_def;
} TermCtrl;

#define MAX_DJ_KEYS         6

typedef struct DJKeyDef_s {
    flag_t         set;
    unsigned long  offset;
    unsigned long  range;
    void         (*override) ();
} DJKeyDef;

void         key_init_m        ();
void         key_clear_m       ();
unsigned int key_get_bytec     ();
int          key_check_sp      (char *);
void         key_handle_sp     (int);
void         key_user_show_comm();      /* user */
void         key_user_mod_comm ();      /* user */

#endif
