/**********************************************
 *  main.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef MAIN_H
#define MAIN_H

#define SELECT_TIMEOUT  50000

enum {
    TIME_OFF,
    TIME_NORM,
    TIME_LEFT
};

#define NUM_MODS 18

typedef struct ModTable_s {
    void         (*init)  ();
    void         (*clear) ();
    unsigned int (*bytec) ();
} ModTable;

void         main_init          (int, char **);
void         main_clear         ();
unsigned int main_get_bytec     ();
void         out_str            (char *);
void         out_str_n          (char *);
void         out_flush          ();
int          have_tty           ();
void         setup_terminal     ();
void         parse_args         ();
void         int_sig_handler    ();
void         alarm_sig_handler  ();
void         winch_sig_handler  ();
void         clear_child_sigs   ();
void         count_child_sigs   ();
void         handle_child_sigs  ();
void         source_file        (char *);
void         source_comm        (); /* user */
void         exit_comm          (); /* user */
void         set_time_stamp_comm(); /* user */

#endif
