/**********************************************
 *  tags.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef TAGS_H
#define TAGS_H

#define ID3_SEPERATOR     '-'
#define TAG_HEADER        "#EXT_INFO"
#define LIST_INFO_TAG     "#LIST_INFO"
#define TAG_CODE          "#$%^&"
#define TAG_HEADER_LEN    8
#define TAG_CODE_LEN      5

enum {
    STR_FILE,
    STR_TAG
};

typedef struct FileInfoDef_s {
    char *type;
    int   offset;
    int   len;
} FileInfoDef;

typedef struct id3tag_s {
    char          magic[3];
    char          songname[30];
    char          artist[30];
    char          album[30];
    char          year[4];
    char          note[30];
    unsigned char style;
} id3tag_t;

struct style_s {
    unsigned char styleid;
    char         *name;
};

void         tag_init             ();
void         tag_clear            ();
unsigned int tag_get_bytec        ();
int          tag_make             (char *, char *);
void         tag_print_styles_comm();	/* user */
void         tag_add_comm         ();	/* user */
void         tag_show_comm        ();	/* user */
void         toggle_read_tags_comm();   /* user */

#endif
