/**********************************************
 *  util.h                                                          
 *                                            
 *  Copyright 2001 Eric Kratzer.               
 *  Includes Xaudio software Copyright (C)
 *           1996-2000 Xaudio Corporation
 *           All Rights Reserved.
 *
 *  This file is part of imp3sh.
 *                                            
 *  imp3sh is free software; you can distribute
 *  it and/or modify it under the terms of the
 *  GNU General Public License as published by
 *  the Free Software Foundation; either version
 *  2 of the License, or (at your option) any
 *  later version.
 *
 *  imp3sh is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of 
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE. See the GNU General Public License
 *  for more details.
 *
 *  You should have recieved a copy of the GNU
 *  General Public License along with imp3sh; if
 *  not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston MA
 *  02111-1307 USA
 *
 *                                            
 **********************************************/

#ifndef UTIL_H
#define UTIL_H

#define BAD_SHELL_CHARACTERS " ;\"\t&|()"

enum {
    AMP_NONE,
    AMP_END,
    AMP_ALL,
    AMP_FRONT,
    AMP_MID
};

void           util_init             ();
void           util_clear            ();
unsigned int   util_get_bytec        ();
void           make_printable        (char *);
int            is_all_space          (char *);
int            is_any_space          (char *);
int            is_upper_c            (char);
int            is_all_digits         (char *);
int            is_digit_range        (char *);
void           get_digit_range       (char *, int *, int *, int, int);
void           remove_end_space      (char *);
int            get_strlen            (char *);
int            remove_newline        (char *);
char          *skip_space            (char *);
char          *grep_str              (char *, char *);
int            grep_against_args     (int, char *);
char          *arg_tokenize          (char *, char **, char, char *);
char          *tokenize              (char *, char **, char);
int            tokenize_to_buf       (DCharBuf *, char *, char);
char          *tokenize_kparen       (char *, char **, char);
int            get_cpos              (char, char *);
int            get_cloc              (char, char *);
char          *safe_strcpy           (char *, char *, int);
int            safe_sprintf          (char *, size_t, const char *, ...);
char          *file_from_path        (char *);
int            get_fline             (FILE *, char *, int);
void           build_string          (va_list, const char *, char *);
void           build_time_string     (time_t, char *, int);
void           build_msec_time_string(struct timeval, char *, int);
FILE          *myfopen               (char *, const char *);
void           mysetenv              (char *, char *);
int            is_url                (char *);
void           add_dir               (int, DCharBuf *, DCharBuf *);
void           unescape_string       (char *);
void           escape_string         (char *);
float          format_bytec          (unsigned int, char *);
struct timeval add_timevals          (struct timeval, struct timeval);
struct timeval sub_timevals          (struct timeval, struct timeval);

#endif
