<?php 
//////////////////////////////////////////////////////////////////////////////
//   Imp3web.php:  Web Jukebox frontend to imp3sh, 
//   used for web control of a local computer jukebox
//Copyright (C) 2001 Jef Spaleta (jspaleta@linuxfreemail.com)
//
//This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//////////////////////////////////////////////////////////////////////////////
//  Revision History
//  v0.1-09/24/2001  Initial public release meant for inclusion with 
//                   the imp3sh project
//  v0.2-12/17/2001  Updated with some button graphics and the beginnings 
//                   of an admin level toolbar and login support 
//                   Added an append/add song interface to build new playlists
//  v0.3-02/05/2002  Added operator and guest users 
//		     Seperated out some controlbar functionality to require 
//		       Operator status
//		     Added support for seek command
//////////////////////////////////////////////////////////////////////////////
//  Todo:
//  *Secure the login process via encrypted password support
//  *Add direct access to the imp3sh controls for the admin users
//  *Seperate out the formatting variables as an input file to read 
//    for themeability
//  *Make use of session variables to keep track of userprefs....
//    ...then make sone userprefs 
//  *Implement multiple user system with config'able user requests limits
//  *Add more images for more buttons 
////////////////////////////////////////////////////////////////////////////// 
session_start();
session_register("user");
session_register("urlflag");
if (! isset($urlflag)) {
  $urlflag=1;
}
//session_register("a");
//session_register("b");
//session_register("c");
//session_register("d");
//session_register("e");
//$user++;
//session_register("user");
/////////////////////////////////////////////////////////////////////////////
////////////////////////       Configs     //////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//Script localation on the webserver
//$impVars["script"]     = substr($SCRIPT_NAME,1);
$impVars["script"]     = "/imp3web.php";

//Image URL Path
$impVars["imgpath"] ="/imp3images/";
//Image control  on=1 off=0
$impVars["imgctl"] = 1;
//Note:  net* variables use only if method = net
//Filesystem location of the network imp3sh client
$impVars["netclient"]  = "/usr/local-dist/bin/imp3net";
//Hostname or ip address of imp3sh host
$impVars["nethost"]    = "goober";
//Port number on imp3sh host
$impVars["netport"]    = "9998";

//Note:  local* variables use only if method = net
//Filesystem location of the local imp3sh client
$impVars["localclient"]= "/usr/local-dist/bin/imp3client";

//Filesystem location of the input and output pipes for the local client
$impVars["inpipe"]     = "/var/tmp/tempin";
$impVars["outpipe"]    = "/var/tmp/tempout";

//Choose the client method: local or net or netmini
$impVars["method"]     ="local";


//Playlist Parsing Section----------------------------------------------
//number indicates segment of playlist name where variable info is encoded
//sections are separated by / 
// If the variables not encoded in the playlist are given a -1 
//example playlist name:  REM/reveal/rock/2001
// genre=2
// artist=0
// album=1
// year=3
// label=-1
//-------------------------------------------------------------------------
$impVars["genre"]      = -1;
$impVars["artist"]     = 0;
$impVars["title"]      = 1;
$impVars["year"]       = -1;
$impVars["label"]       = -1;

//Web Interface Formatting Section
// bgcolor: general page variables
$impVars["bgcolor"]   = "black";
$impVars["linkcolor"]   = "red";
$impVars["vlinkcolor"]   = "red";
$impVars["textcolor"]   = "white";
// header format variables
$impVars["headerwidth"]   = "100%";
$impVars["headerbgcolor"]   = "darkgrey";
$impVars["headertextcolor"]   = "white";
// footer format variables
$impVars["footerwidth"]   = "100%";
$impVars["footerbgcolor"]   = "darkgrey";
$impVars["footertextcolor"]   = "white";
// controlbar format variables
$impVars["ctrlwidth"]   = "80%";
$impVars["ctrlcolor"]   = "779977";
$impVars["ctrllinkcolor"]   = "white";
$impVars["ctrlvlinkcolor"]   = "white";
$impVars["ctrltextcolor"]   = "white";
// list format variables
$impVars["listwidth"]   = "80%";
$impVars["listbgcolor1"]   = "#AAFF55";
$impVars["listbgcolor2"]   = "#55FFAA";
$impVars["listtextcolor"]   = "red";
$impVars["listlinkcolor"]   = "black";
$impVars["listvlinkcolor"]   = "black";
// navigation bar format variables
$impVars["navwidth"]   = "80%";
$impVars["navcolor"]   = "#AAAA55";
$impVars["navlinkcolor"]   = "black";
$impVars["navvlinkcolor"]   = "black";
$impVars["navtextcolor"]   = "black";
// admin bar format variables
$impVars["adminwidth"]   = "80%";
$impVars["admincolor"]   = "#111199";
$impVars["adminlinkcolor"]   = "white";
$impVars["adminvlinkcolor"]   = "white";
$impVars["admintextcolor"]   = "white";
// status page format variables
$impVars["statuswidth"]   = "80%";
$impVars["statuscolor1"]   = "yellow";
$impVars["statuscolor2"]   = "darksalmon";
$impVars["useimages"]       = 0;

//Internal command structure---you shouldn't have to change these
$impVars["localbase"]  =$impVars["localclient"]." ".$impVars["inpipe"]
     ." ".$impVars["outpipe"]." ";
$impVars["netbase"]    =$impVars["netclient"]." ".$impVars["nethost"]
     ." ".$impVars["netport"]." ";


//Add users with passwords here for now
$impUsers["admin"]	="adminpass";
$impUsers["operator"]	="oppass";
$impUsers["guest"]	="guestpass";

//Flags to override op and admin
$impVars["forceadmin"]		=0;
$impVars["forceoperator"]	= 1;

////////////////////////////////////////////////////////////////////////////
//////////////////////////    End Of Configs     ///////////////////////////
////////////////////////////////////////////////////////////////////////////
function imp3($text)
{
  global $impVars;
  if($impVars["method"]=="net"){$command=$impVars["netbase"]."\"".$text."\"";}
  if($impVars["method"]=="netmini"){
    $command=$impVars["netbase"]."\"".$text."\"";
  }
  if($impVars["method"]=="local"){
    $command=$impVars["localbase"]."\"".$text."\"";
  }
  $output=`$command`;
  return $output;

}

function stop()
{
  global $impVars;
  $output=imp3("stop");
  $output=imp3("clearq");
  $output=imp3("uselist default");
}

function pause()
{
  global $impVars;
  $output=imp3("pause");
}

function resume()
{
  global $impVars;
  $output=imp3("resume");
}

function seek($percent)
{
  global $impVars;
  $output=imp3("seek $percent");
}

function mute()
{
  global $impVars;
  $output=imp3("mute");
}

function vol_low()
{
  global $impVars;
  $output=imp3("volume 5 50 50");
}

function vol_normal()
{
  global $impVars;
  $output=imp3("volume 30 50 50");
}

function vol_up()
{
  global $impVars;
  $output=imp3("status");
  $lines = split("^.*Mixer.*:",$output);
  $level=substr($lines[1],8,3);
  $level=$level+5;
  if($level>100){ $level=100;}
  $command="volume ".$level." 50 50";
  $output=imp3($command);
}

function vol_down()
{
  global $impVars;
  $output=imp3("status");
  $lines = split("^.*Mixer.*:",$output);
  $level=substr($lines[1],8,3);
  $level=$level-5;
  if($level<0){ $level=0;}
  $command="volume ".$level." 50 50";
  $output=imp3($command);

}

function play()
{
  global $impVars;
  $output=imp3("play");
}

function currentsong()
{
  global $impVars;
  global $user;
  $output=imp3("status");
  $strings=explode("\n",str_replace("-->","",$output));
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["statuswidth"];
  $tablehead=$tablehead.">";
  echo $tablehead;
  echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
  echo $strings[1];
  echo "</td></tr>";
  echo "<tr align=center bgcolor=".$impVars["statuscolor2"]."><td>";
  echo $strings[2];
  echo "</td></tr>";
  echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
  echo $strings[3];
  echo "</td></tr>";
  echo "<tr align=center bgcolor=".$impVars["statuscolor2"]."><td>";
  echo $strings[4];
  echo "</table>";
}


function nextsong()
{
  global $impVars;
  $output=imp3("next");
  frontpage();
}
function previoussong()
{
  global $impVars;
  $output=imp3("last");
  frontpage();
}

function help()
{
  global $impVars;
  $output=imp3("help");
  echo str_replace("\n","<br>",$output);
}
function frontpage($task="")
{
  if(strcmp($task,"")!=0){
    $tablehead="<table frame=void cellspacing=0 align=center";
    $tablehead=$tablehead." width=".$impVars["statuswidth"];
    $tablehead=$tablehead.">";
    echo $tablehead;
    echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
    echo "The command $task is unimplemented<br>";
    echo "</table>";
  }
  currentsong();
}
function redirect()
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["statuswidth"];
  $tablehead=$tablehead.">";
  echo $tablehead;
  echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
  echo "Sorry, you can not add/play song/album via this page...use the Navbar to browse the list of albums or songs<br>";
  echo "</table>";
}

function button($label="",$class="",$image="",$a="",$b="",$c="",$d="")
{
  global $impVars;
  $bstring="<a ";
  if($class!="") $bstring=$bstring."class=\"".$class."\" ";
  $bstring=$bstring."href=\"";
  $bstring.=($impVars["script"])."?";
  if($a != "") { $bstring=$bstring."a=".$a."&";}
  if($b != "") { $bstring=$bstring."b=".$b."&";}
  if($c != "") { $bstring=$bstring."c=".$c."&";}
  if($d != "") { $bstring=$bstring."d=".$d;}
  $bstring=$bstring."\">";
  if(($image != "") && ($impVars["imgctl"]==1)) {
    $bstring=$bstring."<img src=\"".$impVars["imgpath"].$image
         ."\" border=\"0\" ";
    $bstring=$bstring."ALT=\"".$label."\">";
  } else {
    $bstring=$bstring.$label;
  }
  $bstring=$bstring."</a>";

  echo "$bstring"; 
}

function albumlist($sorttype=-1,$sortitem="")
{
  global $impVars;
  if($impVars["method"]=="netmini"){
    $command=$impVars["localbase"]."\"liststatus\"";
    $output=`$command`;
  } else {
    $output=imp3("liststatus");
  }
  $lines = split("\n",$output);
  $linecount=count($lines);
  $albumcount=0;
  $sortcount=0;
  $active=-1;
  $flag=0;
  //Sort the output lines
  for ($i=0; $i < $linecount ; $i++) 
  {
//find the active album
    if(ereg("^>>>",$lines[$i])) 
    { 
      $album=preg_replace("/[>>> ,--> ,-->\*]/","",$lines[$i]);
      $album=preg_replace("/\n/","",$album);
      if(!eregi("^queue|^default",$album))
      {
        $albums[$albumcount]=$album;
        $active=$albumcount;
        $albumcount++;
        $flag=2;
      }
    }
    //find the inactive albums
    if(ereg("^-->",$lines[$i])) 
    { 
      $album=preg_replace("/[>>> ,--> ,-->\*]/","",$lines[$i]);
      $album=preg_replace("/\n/","",$album);
      if(!eregi("^queue|^default",$album))
      {
        $albums[$albumcount]=$album;
        $albumcount++;
        $flag=1;
      }
    }
    if($flag>0)
    {
      //check to see if we are sorting by type(genre,artist,etc...)
      if($sorttype!=-1) 
      {
        //pick the corresponding field specified by sort type number
        $fields = split("/",$album);
        $field = $fields[$sorttype];
        //check sortitem to see if we are listing albums 
        if($flag==2) 
        {
          $active=$sortcount;
        }
        if($sortitem!="") 
        {
          //if there is a sortitem present list those items 
          //corresponding to sortitem
          if($sortitem==$field) 
          {
            $sortlist[$sortcount]=$album;
            $sortcount++;
          }
        } else {
          $sortlist[$sortcount]=$field;
          $sortcount++;
        }
      } 
      $flag=0;
    }
  }

  if($sorttype!=-1) 
  {
    if($sortitem!="") 
    {
      sort($sortlist);
      $sortcount=count($sortlist);
      echo "<table frame=void cellspacing=0 align=center width="
           .$impVars["listwidth"].">";
      for ($i=0; $i < $sortcount ; $i++) 
      {
        $album=$sortlist[$i];
        if(($i % 2)==0) {
          $color=$impVars["listbgcolor1"];
        } else {
          $color=$impVars["listbgcolor2"];
        }       
        echo "<tr align=center bgcolor=".$color
            ." ><td align=left class=\"list\">";
        if($active==$i) echo "<b>";
        echo $album;
        if($active==$i) echo "</b>";
        echo "</td><td align=right width=20>";
        button("songlist","list","songs.png","songlist",$album);
        echo "</td><td align=right>";
  if ($impVars["forceoperator"]==1 or $user=="admin" or $user=="operator" ) {
        button("playalbum ","list","play.png","playalbum","$album");
  }
        echo "</td><td align=right>";
        button("addalbum ","list","add.png","addalbum","$album");
      }
      echo "</table>";
    } else {
      sort($sortlist);      
      $newlist=array_unique($sortlist);    
      $sortcount=count($sortlist);
      echo "<table frame=void cellspacing=0 align=center width="
           .$impVars["listwidth"].">";
      $j=0;
      for ($i=0; $i < $sortcount ; $i++) 
      {
        $album=$newlist[$i];
          if($album!="")
          {
            if(($j % 2)==0) {
              $color=$impVars["listbgcolor1"];
            } else {
              $color=$impVars["listbgcolor2"];
            }       
            echo "<tr align=center bgcolor=".$color
                 ." ><td align=left class=\"list\">";
            if($active==$i) echo "<b>";
            echo $album;
            if($active==$i) echo "</b>";
            echo "</td><td align=right>";
            button("List","list","list.png","sortlist","$sorttype",$album);
            $j++;
          }
      }
      echo "</table>";

    }
  } else {

    sort($albums);
    $albumcount=count($albums);
    echo "<table frame=void cellspacing=0 align=center width="
         .$impVars["listwidth"].">";
    for ($i=0; $i < $albumcount ; $i++) 
    {
      $album=$albums[$i];
          if(($i % 2)==0) {
            $color=$impVars["listbgcolor1"];
          } else {
            $color=$impVars["listbgcolor2"];
          }       
          echo "<tr align=center bgcolor=".$color
               ." ><td align=left class=\"list\">";
          if($active==$i) echo "<b>";
          echo $album;
          if($active==$i) echo "</b>";
          echo "</td><td align=right>";
          button("songlist","list","songs.png","songlist",$album);
          echo "</td><td align=right>";
  if ($impVars["forceoperator"]==1 or $user=="admin" or $user=="operator" ) {
          button("playalbum","list","play.png","playalbum","$album");
  }
          echo "</td><td align=right>";
          button("addalbum","list","add.png","addalbum","$album");
    }
    echo "</table>";
  }
}

function songlist($album,$listonly)
{
  global $impVars;
  $command="editlist ".$album;
  $output=imp3($command);
  $command="printlist";
  $output=imp3($command);
  
  $lines = split("\n",$output);
  $linecount=count($lines);
  $songcount=0;
  $active=-1;
  for ($i=0; $i < $linecount ; $i++) 
  {
      if(ereg("^\|\|\|",$lines[$i])) 
      { 
        $songs[$songcount]=$lines[$i];
        $songcount++;
      }
      if(ereg("^>>>",$lines[$i])) 
      { 
        $songs[$songcount]=$lines[$i];
        $active=$songcount;
        $songcount++;
      }
  }
  $songcount=count($songs);
  echo "<table frame=void cellspacing=0 align=center width="
       .$impVars["listwidth"].">";
  for ($i=0; $i < $songcount ; $i++) 
  {
    if(($i % 2)==0) {
      $color=$impVars["listbgcolor1"];
    } else {
      $color=$impVars["listbgcolor2"];
    }       
    echo "<tr align=left bgcolor=".$color." ><td class=\"list\">";
    $song=preg_replace("/[>>>,|||].*> /","",$songs[$i]);
    if($listonly!=1){
      if($active==$i) echo "<b>";
      echo $song;
      if($active==$i) echo "</b>";
      echo "</td><td align=right>";
  if ($impVars["forceoperator"]==1 or $user=="admin" or $user=="operator" ) {
      echo button("playsong","list","","playsong",$album,$song,"$i");
  }
      echo "</td><td align=right>";
      echo button("addsong","list","","addsong",$album,$song,$i);
    } else {
      echo $song;
    }
  }
  echo "</table>";
}

function quelist()
{
  global $impVars;
  $output=imp3("printq");
  $lines = split("\n",$output);
  $linecount=count($lines);
  $songcount=0;
  $active=-1;
  for ($i=0; $i < $linecount ; $i++) 
  {
      if(ereg("^\|\|\|",$lines[$i])) 
      { 
        $songs[$songcount]=$lines[$i];
        $songcount++;
      }
      if(ereg("^>>>",$lines[$i])) 
      { 
        $songs[$songcount]=$lines[$i];
        $active=$songcount;
        $songcount++;
      }
    
  }
  $songcount=count($songs);
  echo "<table frame=void cellspacing=0 align=center width="
       .$impVars["listwidth"].">";
  for ($i=0; $i < $songcount ; $i++) 
  {
    if(($i % 2)==0) {
      $color=$impVars["listbgcolor1"];
    } else {
      $color=$impVars["listbgcolor2"];
    }       
    echo "<tr align=center bgcolor=".$color." ><td align=left class=\"list\">";
  $song=preg_replace("/[>>>,|||].*> /","",$songs[$i]);
  if($active==$i) echo "<b>";
  echo $song;
  if($active==$i) echo "</b>";
  }
  echo "</table>";
}

function queclear()
{
  global $impVars;
  $output=imp3("clearq");

}

function addsong($album,$index)
{
  global $impVars;
  global $urlflag;
  $command="uselist ".$album;
  $output=imp3($command);
  $command="addq ".$index;
  $output=imp3($command);
  $output=imp3("uselist default");
  $urlflag=1;
  quelist();
}

function playsong($album,$index)
{
  global $impVars;
  global $urlflag;
  $command="uselist ".$album;
  $output=imp3($command);
  $command="playindex ".$index;
  $output=imp3($command);
  $urlflag=1;
  frontpage();
}

function playalbum($album)
{
  global $impVars;
  global $urlflag;
  $output=imp3("stop");
  $output=imp3("clearq");
  $command="uselist ".$album;
  $output=imp3($command);
  $command="addq 0-";
  $output=imp3($command);
  $output=imp3("play");
  $output=imp3("uselist default");
  $urlflag=1;
  quelist();
}

function addalbum($album)
{
  global $impVars;
  global $urlflag;
  $command="uselist ".$album; 
  $output=imp3($command);
  $command="addq 0-";
  $output=imp3($command);
  $output=imp3("uselist default");
  $urlflag=1;
  quelist();
}

function menubar()
{
echo "$script";
}

function navbar()
{
  global $impVars;
  echo "<DIV class=\"nav\">";
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["navwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["navcolor"];
  $tablehead=$tablehead."><tr align=center><td>";
  echo $tablehead;
  button("login","nav","","login");echo "::"; 
  button("Home","nav","","");echo "::"; 
  button("albums","nav","","albums");echo "::"; 
  $test=$impVars["artist"];
  if($impVars["artist"] > -1) {
    button("artists","nav","","artists");echo "::";
  } 
  if($impVars["genre"] > -1) {button("genre","nav","","genre");echo "::";} 
  if($impVars["label"]>-1) {button("label","nav","","label");echo "::";} 
  if($impVars["year"]>-1) {button("year","nav","","year");echo "::";} 
  button("que","nav","","que");echo "::"; 
  button("logout","nav","","logout"); 
  echo "</table></div>";

}
function controlbar()
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["ctrlwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["ctrlcolor"];
  $tablehead=$tablehead."><tr align=center ><td>";
  echo $tablehead;
  button("queclear","ctrl","","queclear");echo "::"; 
  button("stop","ctrl","","stop");echo":";
  button("play","ctrl","","play");echo":";
  button("pause","ctrl","","pause");echo":";
  button("resume","ctrl","","resume");echo":";
  button("fseek","ctrl","","fseek");echo":";
  button("rseek","ctrl","","rseek");echo":";
  button("next","ctrl","","next");echo":";
  button("previous","ctrl","","previous");echo"::";
  button("mute","ctrl","","mute");
  echo "</td></tr></table>";
}
function adminbar()
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["adminwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["admincolor"];
  $tablehead=$tablehead."><tr align=center ><td>";
  echo $tablehead;
  button("append","admin","","append");echo":";
  button("delete","admin","","delete");echo":";
  button("save","admin","","save");echo":";
  button("reload","admin","","reload");echo"::";
  button("logout","admin","","logout");
  echo "</td></tr></table>";
}

function volbar()
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["ctrlwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["ctrlcolor"];
  $tablehead=$tablehead."><tr align=center ><td>";
  echo $tablehead;
  button("vol_down","ctrl","","vol_down");echo "::";
  button("1","ctrl","","v1");echo":";
  button("2","ctrl","","v2");echo":";
  button("3","ctrl","","v3");echo":";
  button("4","ctrl","","v4");echo":";
  button("5","ctrl","","v5");echo":";
  button("6","ctrl","","v6");echo":";
  button("7","ctrl","","v7");echo":";
  button("8","ctrl","","v8");echo":";
  button("9","ctrl","","v9");echo":";
  button("10","ctrl","","v10");echo"::";
  button("vol_up","ctrl","","vol_up");
  echo "</td></tr></table>";
}

function Head()
{
  global $impVars;
  global $user;
  $headstring="<html><head><title>Spatula Jukebox</title>";
  $headstring=$headstring."<STYLE TYPE-\"type/css\"><!-- "; 
  $headstring=$headstring.".list {color:".$impVars["listtextcolor"]."}";
  $headstring=$headstring.".header {color:".$impVars["headertextcolor"]."}";
  $headstring=$headstring.".footer {color:".$impVars["footertextcolor"]."}";
  $headstring=$headstring.".nav {color:".$impVars["navtextcolor"]."}";
  $headstring=$headstring.".ctrl {color:".$impVars["ctrltextcolor"]."}";
  $headstring=$headstring."A:link.nav {color:".$impVars["navlinkcolor"]."}";
  $headstring=$headstring."A:visited.nav {color:".$impVars["navvlinkcolor"]."}";
  $headstring=$headstring."A:link.admin {color:".$impVars["adminlinkcolor"]."}";
  $headstring=$headstring."A:visited.admin {color:".$impVars["adminvlinkcolor"]."}";
  $headstring=$headstring."A:link.ctrl {color:".$impVars["ctrllinkcolor"]."}";
  $headstring=$headstring."A:visited.ctrl {color:".$impVars["ctrlvlinkcolor"]."}";
  $headstring=$headstring."A:link.list {color:".$impVars["listlinkcolor"]."}";
  $headstring=$headstring."A:visited.list {color:".$impVars["listvlinkcolor"]."}";

  $headstring=$headstring." --></STYLE>";
  $headstring=$headstring."</head><body";
  $headstring=$headstring." bgcolor=".$impVars["bgcolor"];
  $headstring=$headstring.">";
  echo $headstring;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["headerwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["headerbgcolor"];
  $tablehead=$tablehead."><tr><td class=\"header\">";
  echo $tablehead;
  echo "Welcome to Imp3web (V0.3): the Imp3sh powered WebJukebox";
  echo "</table>";
  
//  menubar();
  if ($impVars["forceadmin"]==1 or $user=="admin" ) { adminbar(); }  
  if ($impVars["forceoperator"]==1 or $user=="admin" or $user=="operator" ) {
    controlbar(); 
  }
  navbar();

  volbar();

}

function Foot()
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["footerwidth"];
  $tablehead=$tablehead." bgcolor=".$impVars["footerbgcolor"];
  $tablehead=$tablehead."><tr><td class=\"footer\">";
  echo $tablehead;
  echo "Copyright (2) 2001 Jef Spaleta (spatula@linuxfreemail.com)";
  echo "</table>";

 echo "</body></html>";
}

function logoutpage()
{
  global $impVars;
  global $impUsers;

    $tablehead="<table frame=void cellspacing=0 align=center";
    $tablehead=$tablehead." width=".$impVars["statuswidth"];
    $tablehead=$tablehead.">";
    echo $tablehead;
    echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
    echo "User <b>".$user."</b> is now logged out";
    echo "</table>";
}
function loginpage($a,$b,$c,$d)
{
  global $impVars;
  global $impUsers;
  global $user;
    $tablehead="<table frame=void cellspacing=0 align=center";
    $tablehead=$tablehead." width=".$impVars["statuswidth"];
    $tablehead=$tablehead.">";
    echo $tablehead;
  if($d!="on") {
    echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
    echo "<form action=\"".$impVars["script"]."\" method=\"post\">";
    echo "LoginName: <input size=20 type=\"text\" name=\"b\">";
  //  echo "<tr align=right bgcolor=".$impVars["statuscolor2"]."><td>";
    echo "&nbsp &nbsp Password: <input size=20 type=\"password\" name=\"c\">";
    echo "&nbsp &nbsp <input value=\"Enter\" type=\"submit\">";
    echo "<input name=\"a\" value=\"login\" type=\"hidden\">";
    echo "<input name=\"d\" value=\"on\" type=\"hidden\">";
    echo "</form>"; 
  } else {
    if(isset($impUsers[$b]) and $impUsers[$b]==$c) {
      echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
      echo "Successfully logged in as <b>".$b."</b>";
      $user=$b;
      
    } else {
      echo "<tr align=right bgcolor=".$impVars["statuscolor2"]."><td>";
      echo "Incorrect Login, try again";
      echo "<tr align=center bgcolor=".$impVars["statuscolor1"]."><td>";
      echo "<form action=\"".$impVars["script"]."\" method=\"post\">";
      echo "Hmm LoginName: <input size=20 type=\"text\" name=\"b\">";
      echo "&nbsp &nbsp Password: <input size=20 type=\"text\" name=\"c\">";
      echo "&nbsp &nbsp <input value=\"Enter\" type=\"submit\">";
      echo "<input name=\"a\" value=\"login\" type=\"hidden\">";
      echo "<input name=\"d\" value=\"on\" type=\"hidden\">";
      echo "</form>"; 
    }
  }
  echo "</table>";
  if ($user=="admin" ) { adminbar(); }  
}

function appendpage($a,$b,$c,$d,$e)
{
  global $impVars;
  $tablehead="<table frame=void cellspacing=0 align=center";
  $tablehead=$tablehead." width=".$impVars["statuswidth"];
  $tablehead=$tablehead.">";
  echo $tablehead;
  if(substr(realpath($d),0,10)!="/home/mp3s") { $d="/home/mp3s/"; }
  if($e=="") { $e="artist/albumname"; }
  if($oldplaylist=="") { $oldplaylist="/home/mp3s/UTILS/playlist.imp"; }
  if($newplaylist=="") { $newplaylist="/var/tmp/playlist.imp"; }
  echo "<tr align=left bgcolor=".$impVars["statuscolor1"]."><td>";
  echo "<form action=\"".$impVars["script"]."\" method=\"post\">";
  echo "Path to files: <input size=60 value=\"".realpath($d)
       ."\" type=\"text\" name=\"d\"><br>";
  echo "<tr align=left bgcolor=".$impVars["statuscolor2"]."><td>";
  echo "Name of Songlist to edit: <input value=\"".$e."\" size=30 
     type=\"text\" name=\"e\"><br>";
//  echo "<tr align=left bgcolor=".$impVars["statuscolor1"]."><td>";
//  echo "Path to old playlist: <input size=60 
//     value=\"".$oldplaylist."\" type=\"text\" name=\"oldplaylist\"><br>";
//  echo "<tr align=left bgcolor=".$impVars["statuscolor2"]."><td>";
//  echo "Path to new playlist: <input size=60 
//     value=\"".$newplaylist."\" type=\"text\" name=\"newplaylist\"><br>";
  echo "<tr align=right bgcolor=".$impVars["statuscolor1"]."><td>";
  if($b=="on") {
    echo "Write to playlist: <input type=\"checkbox\" name=\"c\">   ";
    echo "Create Albumlist: <input type=\"checkbox\" checked name=\"b\">";

  } else {  
    echo "Create Albumlist: <input type=\"checkbox\" name=\"b\">";
  }
  echo "<input value=\"Enter\" type=\"submit\">";
  echo "<input name=\"a\" value=\"append\" type=\"hidden\">";
  echo "</form>"; 
  echo "</table>";

if($a=="append") {
  if($b!="on") {
//    echo "File listings:<br>";
    $command="ls ".escapeshellarg(realpath($d))."/";
    $output=`$command`;
    $songs=explode("\n",$output); 
    $songcount=count($songs);
    echo "<table frame=void cellspacing=0 align=center width="
         .$impVars["listwidth"].">";
     for ($i=0; $i < $songcount-1 ; $i++) {
        if(($i % 2)==0) {
          $color=$impVars["listbgcolor1"];
        } else {
          $color=$impVars["listbgcolor2"];
        }       
       echo "<tr align=center bgcolor=".$color
            ." ><td align=left class=\"list\">";
       $ftype=filetype(realpath($d)."/".$songs[$i]);
       if($ftype=="dir") {
         echo "<a href=\"".$impVars["script"]."?a=append&d="
           .realpath($d)."/".$songs[$i]."\">";
       }
       echo $songs[$i];
       if($ftype=="dir") {
         echo "</a></td><td>";
         button("Add Dir","list","","append","on","",realpath($d)
              ."/".$songs[$i]);
         echo "</td>";
       } else {
         echo "</td><td>";
         button("Add File","list","","append","on","",realpath($d)."/".$songs[$i]);
         echo "</td>";

       }
     }
   echo "</table>";
  } else {
    if($c!="on") {
      echo "<table frame=void cellspacing=0 align=center width="
           .$impVars["listwidth"].">";
      $color=$impVars["listbgcolor2"];
      echo "<tr align=center bgcolor=".$color
           ." ><td align=center class=\"list\">";
      echo "<b>Current Songlist entries:</b><br>";
      echo "</table>";
      $command="editlist default";
      $output=imp3($command);  
      $command="editlist ".$e;
      $output=imp3($command);  
      if(strstr($output,":->")!=FALSE) {
        songlist($e,1);
      } else {
        $color=$impVars["listbgcolor1"];
        echo "<table frame=void cellspacing=0 align=center width="
           .$impVars["listwidth"].">";
        echo "<tr align=center bgcolor=".$color
           ." ><td align=center class=\"list\">";
        echo "<b>List not found</b>";
        echo "</table>";
      }
      echo "<table frame=void cellspacing=0 align=center width="
           .$impVars["listwidth"].">";
      $color=$impVars["listbgcolor2"];
      echo "<tr align=center bgcolor=".$color
           ." ><td align=center class=\"list\">";
      echo "<b>New Songlist entry preview:</b><br>";
      $command="ls ".$d;
      $output=`$command`;
      $songs=explode("\n",$output); 
      $songcount=count($songs);
      for ($i=0; $i < $songcount-1 ; $i++) {
        if(($i % 2)==0) {
          $color=$impVars["listbgcolor1"];
        }   else {
          $color=$impVars["listbgcolor2"];
        }       
        echo "<tr align=center bgcolor=".$color
            ." ><td align=left class=\"list\">";
//        echo "#EXT_INFO 0<br>";
        echo $songs[$i];
        echo "<br>";
      }
   echo "</table>";
    } else {
      $command="ls ".$d;
      $output=`$command`;
      $songs=explode("\n",$output); 
      $songcount=count($songs);
      $command="addlist ".$e;
      $output=imp3($command);  
      $command="editlist ".$e;
      $output=imp3($command);  
      $command="viewF";
      $output=imp3($command);  
      $ftype=filetype(realpath($d));
      if($ftype=="dir") {
        $command="addiR ".$d;
        $output=imp3($command);  
      } else {
        $command="addfile ".$d;
        $output=imp3($command);  
      }
      $command="viewTF";
      $output=imp3($command);  
      $command="editlist default";
      $output=imp3($command);  

    }
  }
} else {
 echo "Intructions for using this system<br>";
}
//  echo "</body></html>";




}


Head();

switch($a)
{
  case "albums":
    albumlist();
    break;
  case "artists":
    albumlist($impVars["artist"]);
    break;
  case "genre":
    albumlist($impVars["genre"]);
    break;
  case "year":
    albumlist($impVars["year"]);
    break;
  case "label":
    albumlist($impVars["label"]);
    break;
  case "sortlist":
    albumlist($b,$c);
    break;
  case "playalbum":
  if ($urlflag==1 ) {
    redirect();
  } else {
    playalbum($b);
  }
    break;
  case "addalbum":
  if ($urlflag==1 ) {
    redirect();
  } else {
    addalbum($b);
  }
    break;
  case "que":
    quelist();
    break;
  case "queclear":
    queclear();
    break;
  case "next":
    nextsong();
    break;
  case "previous":
    previoussong();
    break;
  case "play":
    play();
    break;
  case "stop":
    stop();
    break;
  case "pause":
    pause();
    break;
  case "resume":
    resume();
    break;
  case "rseek":
    seek("-5");
    break;
  case "fseek":
    seek("+5");
    break;
  case "help":
  case "help":
    help();
    break;
  case "songlist":
    songlist($b,0);
    break;
  case "addsong":
  if ($urlflag==1 ) {
    redirect();
  } else {
    addsong($b,$c);
  }
    break;
  case "playsong":
  if ($urlflag==1 ) {
    redirect();
  } else {
    playsong($b,$d);
  }
    break;
  case "vol_up":
    vol_up();
    break;
  case "vol_down":
    vol_down();
    break;
  case "mute":
    mute();
    break;
  case "v1":
    $command="volume 10 50 50";
    $output=imp3($command);
    break;
  case "v2":
    $command="volume 20 50 50";
    $output=imp3($command);
    break;
  case "v3":
    $command="volume 30 50 50";
    $output=imp3($command);
    break;
  case "v4":
    $command="volume 40 50 50";
    $output=imp3($command);
    break;
  case "v5":
    $command="volume 50 50 50";
    $output=imp3($command);
    break;
  case "v6":
    $command="volume 60 50 50";
    $output=imp3($command);
    break;
  case "v7":
    $command="volume 70 50 50";
    $output=imp3($command);
    break;
  case "v8":
    $command="volume 80 50 50";
    $output=imp3($command);
    break;
  case "v9":
    $command="volume 90 50 50";
    $output=imp3($command);
    break;
  case "append";
    appendpage($a,$b,$c,$d,$e);
    break;
  case "login";
    loginpage($a,$b,$c,$d);
    break;
  case "logout";
    session_unregister("user");
    logoutpage();
    break;
  case "save";
    $command="saveall /var/tmp/playlist.imp";
    $output=imp3($command);  
    frontpage($a);
    break;
  case "reload";
    $command="dellist *";
    $output=imp3($command);  
    $command="loadall /var/tmp/playlist.imp";
    $output=imp3($command);  
    frontpage($a);
    break;
  default:
    frontpage($a);
}   
switch($a)
{
  case "addalbum";
  case "playalbum";
  case "addsong";
  case "playsong";
    break;
  default:
    $urlflag=0;
}
Foot();
?>



